VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Items"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Copyright (C) 1997-2010 Kei Sakamoto
' {t@Cyі{t@Cgč쐬vO
' fzz֎~܂B

'ACehc쐬pJE^
Private IDCount As Long

'ACeꗗ
Private colItems As New Collection

'NX̉
Private Sub Class_Terminate()
Dim i As Integer
    
    With colItems
        For i = 1 To .Count
            .Remove 1
        Next
    End With
    Set colItems = Nothing
End Sub

'ForEachp֐
Public Function NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = colItems.[_NewEnum]
End Function


'XgɃACeǉ
Public Function Add(Name As String) As Item
Dim new_item As Item
    
    If Not IDList.IsDefined(Name) Then
        Set Add = Nothing
        Exit Function
    End If
    
    Set new_item = New Item
    Set Add = new_item
    With new_item
        .Name = Name
        .ID = CreateID(Name)
    End With
    colItems.Add new_item, new_item.ID
End Function

'VACehc쐬
Private Function CreateID(iname As String) As String
    Do
        IDCount = IDCount + 1
    Loop Until Not IsDefined2(iname & "_" & Format$(IDCount))
    CreateID = iname & "_" & Format$(IDCount)
End Function

'Xgɓo^ĂACȇ
Public Function Count() As Integer
    Count = colItems.Count
End Function

'XgACe폜
Public Sub Delete(Index As Variant)
    colItems.Remove Index
End Sub

'w肳ꂽACe
Public Function Item(Index As Variant) As Item
Dim it As Item
Dim iname As String

    On Error GoTo ErrorHandler
    Set Item = colItems.Item(Index)
    
    'jĂȂH
    If Item.Exist Then
        Exit Function
    End If

ErrorHandler:
    'Ȃ΃ACeŌ
    iname = CStr(Index)
    For Each it In colItems
        With it
            If .Name = iname And .Exist Then
                Set Item = it
                Exit Function
            End If
        End With
    Next
    Set Item = Nothing
End Function

'w肳ꂽACeo^Ă邩H
Public Function IsDefined(Index As Variant) As Boolean
Dim it As Item
Dim iname As String

    On Error GoTo ErrorHandler
    Set it = colItems.Item(Index)
    
    'jꂽACe͓o^ĂȂƂ݂Ȃ
    If it.Exist Then
        IsDefined = True
        Exit Function
    End If
    
ErrorHandler:
    'Ȃ΃ACeŌ
    iname = CStr(Index)
    For Each it In colItems
        With it
            If .Name = iname And .Exist Then
                IsDefined = True
                Exit Function
            End If
        End With
    Next
    IsDefined = False
End Function

'ACeExittO𖳎ăACe
Public Function IsDefined2(Index As Variant) As Boolean
Dim it As Item

    On Error GoTo ErrorHandler
    Set it = colItems.Item(Index)
    IsDefined2 = True
    Exit Function

ErrorHandler:
    IsDefined2 = False
End Function

'Xgɓo^ꂽACeAbvf[g
Public Sub Update()
Dim it As Item
    
    'jꂽACe폜
    For Each it In colItems
        With it
            If Not .Exist Then
                colItems.Remove .ID
            End If
        End With
    Next
    
    'Nf[^̐
    For Each it In colItems
        With it
            If Not .Unit Is Nothing Then
                Set .Unit = UList.Item(.Unit.ID)
            End If
        End With
    Next
End Sub


'f[^t@CɃZ[u
Public Sub Save()
Dim i As Integer

    Write #SaveDataFileNumber, IDCount
    Write #SaveDataFileNumber, Count
    For i = 1 To Count
        With Item(i)
            Write #SaveDataFileNumber, .Name
            If .Unit Is Nothing Then
                Write #SaveDataFileNumber, .ID, "-"
            Else
                Write #SaveDataFileNumber, .ID, .Unit.ID
            End If
        End With
    Next
End Sub

'f[^t@C烍[h
Public Sub Load()
Dim num As Integer
Dim new_item As Item
Dim iname As String
Dim iid As String
Dim i As Integer
Dim dummy As String

    If EOF(SaveDataFileNumber) Then
        Exit Sub
    End If
    
    Input #SaveDataFileNumber, IDCount
    Input #SaveDataFileNumber, num
    For i = 1 To num
        Set new_item = New Item
        With new_item
            'Name
            Input #SaveDataFileNumber, iname
            'ID, Unit
            Input #SaveDataFileNumber, iid, dummy
            
            If Not IDList.IsDefined(iname) Then
                ErrorMessage iname & "̃f[^`Ă܂"
                StopBGM
                End
            End If
            
            .Name = iname
            .ID = iid
        End With
        colItems.Add new_item, iid
    Next
End Sub

'Nt@C烍[h
Public Sub LoadLinkInfo()
Dim num As Integer, i As Integer
Dim dummy As String

    If EOF(SaveDataFileNumber) Then
        Exit Sub
    End If
    
    'IDCount
    Line Input #SaveDataFileNumber, dummy
    
    Input #SaveDataFileNumber, num
    For i = 1 To num
        'Name
        Line Input #SaveDataFileNumber, dummy
        'ID, Unit
        Line Input #SaveDataFileNumber, dummy
    Next
End Sub


'ꎞfpf[^t@CɃZ[u
Public Sub Dump()
Dim it As Item

    Write #SaveDataFileNumber, Count
    For Each it In colItems
        it.Dump
    Next
End Sub

'ꎞfpf[^t@C烍[h
Public Sub Restore()
Dim i As Integer, num As Integer
Dim it As Item
    
    With colItems
        For i = 1 To .Count
            .Remove 1
        Next
    End With
    
    Input #SaveDataFileNumber, num
    
    For i = 1 To num
        Set it = New Item
        With it
            .Restore
            colItems.Add it, .ID
        End With
    Next
End Sub

'ꎞfpf[^̃Nt@C烍[h
Public Sub RestoreLinkInfo()
Dim it As Item
Dim num As Integer

    Input #SaveDataFileNumber, num
    
    For Each it In colItems
        it.RestoreLinkInfo
    Next
End Sub

'ꎞfpf[^̃p[^t@C烍[h
Public Sub RestoreParameter()
Dim it As Item
Dim num As Integer

    Input #SaveDataFileNumber, num
    
    For Each it In colItems
        it.RestoreParameter
    Next
End Sub


'XgNA
Public Sub Clear()
Dim i As Integer

    For i = 1 To Count
        Delete 1
    Next
End Sub


